#!/usr/bin/perl -wT
use CGI qw(:standard *table);
use CGI::Carp qw(warningsToBrowser fatalsToBrowser);
use strict;

# tighten up the PATH
$ENV{"PATH"} = "/usr/bin";

print header;
print start_html( -title=>"Compiler Lab #4 - Code generation",
		  -style=>{-src=>"../style.css"}), "\n";

print "<div id=&quot;nav&quot;>";
print "<a href = \"http://www.cs.wpi.edu/~kal/courses/compilers/modules.html\">[Modules]</a>";
print "<a href = \"http://www.cs.wpi.edu/~kal/courses/compilers/syllabus.html\">[Syllabus]</a>";
print "<a href = \"http://www.cs.wpi.edu/~kal/courses/compilers/project/index.html\">[Project]</a>";
print "<a href = \"http://users.wpi.edu/~alexvo/index.html\">[Lab Index]</a>";
print "</div>";

print h1("Compiler Lab #4 - Code generation"), "\n";
print h2("by Todd Cooper &amp; Karen Lemone"), "\n";

my $instruct=<<ENDINSTRUCT;
<p>
This lab will prepare you to do Project, Part 4 which uses the abstract syntax tree created in
Project, part 3 to generate code.
</p>

<p>
As in the other labs, the yacc (bison) program is in the left box and input to that program is in 
the right box.  The lex code is below.
</p>

<p> 
When you press the button <em>Edit the text and click me</em>, the following 
will happen.
</p>
<ol>
<li>Like the other labs, the yacc code will be submitted to bison (yacc), 
flex (lex), the cc compiler, 
and the resultant program will be run on the input.</li>
<li>The results will be displayed on the bottom of the page.<br/> 
You might have to scroll down in your browser to see them.</li>
</ol>

<p>
<b>Step 0</b> Run the input  and look at the output.
Note that pseudocode for a stack machine is produced. 
</p>

<p>
<b>Step 1</b> Change the yacc/bison grammar so that it recognizes division and will 
divide an expression and add that node to the AST tree.<br/>
Add an expression to the input and show that the division works.<br/>
(You should have this from the last lab.)
Make the divide operation print the correct pseudo-assembler in the 
generate function.
</p>

<p>
<b>Step 2</b> Now add code to generate pseudo assembly for the <code>pow()</code>
funtion (^) to get the power of two numbers,
adding the pow node to the ast tree (as done in the last lab).
</p>

<ul>
<li>Run an expression as input to show that power works.</li>
<li>Add the pseudo code to run the power function.</li>
<li>For simplicity you can assume the machine has an opcode that does power,
or you can loop the multiplication.</li>
</ul>


<p>
<b>Step 3</b> On to Project, part 4! Now you are a compiler designer! 
</p>

ENDINSTRUCT
print p, start_form(-method => "post",
		    -action => "code_generation_lab.cgi#output"), "\n";

print $instruct;
my $codefilename = "parsing_lab_$$";
my $inputlexcode = param("lex_code");
my $inputyacccode = param("yacc_code");
my $inputtext = param("input");

open(CODELEXF,">$codefilename.l") 
    or dienice("Couldn't open $codefilename.l for creation: $!");
print CODELEXF $inputlexcode;
close CODELEXF;
open(CODEYACCF,">$codefilename.y") 
    or dienice("Couldn't open $codefilename.y for creation: $!");
print CODEYACCF $inputyacccode;
close CODEYACCF;
open(INPUTF,">$codefilename.input") 
    or dienice("Couldn't open $codefilename.input for creation: $!");
print INPUTF $inputtext;
close INPUTF;

my $flexline = "flex -o$codefilename.lex.c $codefilename.l";
my $yaccline = "bison -d $codefilename.y";
my $compileline1 = "cc -g -c $codefilename.lex.c";
my $compileline2 = "cc -g -c $codefilename.y.c";
my $compileline3 = "cc -g -o$codefilename $codefilename.lex.o $codefilename.y.o -lfl -lm";
my $runline = "./$codefilename < $codefilename.input";
my $output;
if (runandoutput($yaccline))
{
    $output .= "The bison/yacc command returned the error: $?\n";
}
elsif (!myrename("$codefilename.tab.h", "parsing_lab.h"))
{
    $output .= "The mv 1 command returned the error: $?\n";
}
elsif (!myrename("$codefilename.tab.c", "$codefilename.y.c"))
{
    $output .= "The mv 2 command returned the error: $?\n";
}
elsif (runandoutput($flexline))
{
    $output .= "The flex command returned the error: $?\n";
}
elsif (runandoutput($compileline1))
{
    $output .= "The compile 1 command returned the error: $?\n";
}
elsif (runandoutput($compileline2))
{
    $output .= "The compile 2 command returned the error: $?\n";
}
elsif (runandoutput($compileline3))
{
    $output .= "The compile 3 command returned the error: $?\n";
}
elsif (runandoutput($runline))
{
    $output .= "The run command returned the error: $?\n";
}

print start_table();
print Tr(td({colspan => 2},
	    [submit(-name=>'submit',
		    -value=>'Edit the text and click me')])), "\n";
print Tr(td( {width => "50%"}, ["Yacc/Bison Parsing Program"]),
	 td( {width => "50%"}, ["Yacc/Bison Parsing Input"])), "\n";
print Tr(td( {width => "50%"}, textarea(-name => 'yacc_code',
					-default => $inputyacccode,
                                        -rows => 21,
                                        -columns => 42)),
         td( {width => "50%"}, textarea(-name => 'input',
					-default => $inputtext,
                                        -rows => 21,
                                        -columns => 42))), "\n";
print Tr(td( {width => "50%"}, ["Lex Scanner Program"])), "\n";
print Tr(td( {width => "50%"}, textarea(-name => 'lex_code',
					-default => $inputlexcode,
                                        -rows => 21,
                                        -columns => 42))), "\n";

my $thtext = "Edit the program and input above" . br();
$thtext .= "and click on the button to see the result.";
print Tr(th( {align => "left"}, [$thtext] ));

print end_table(), "\n";
my $restext = "The result output or running the input on the parsing program";
$restext .= " is below.";

print "<a name=\"output\"></a>";
print p($restext), "\n";
print "<fieldset><legend>OUTPUT</legend>";
print p($output), "\n";
print "</fieldset>";

print endform(), "\n";

my $htmlstrict=<<ENDHTMLSTRICT;
<p>
    <a href="http://validator.w3.org/check?uri=referer"><img
        src="http://www.w3.org/Icons/valid-xhtml10-blue"
        alt="Valid XHTML 1.0 Transitional" height="31" width="88" /></a>
  </p>
ENDHTMLSTRICT
print $htmlstrict;
print end_html;

# cleanup files we made
unlink("$codefilename.l");
unlink("$codefilename.y");
unlink("$codefilename.input");
unlink("$codefilename.tab.h");
unlink("$codefilename.tab.c");
unlink("$codefilename.lex.c");
unlink("$codefilename.y.c");
unlink("$codefilename.lex.o");
unlink("$codefilename.y.o");
unlink("$codefilename");
unlink("parsing_lab.h");

sub runandoutput
{
    my($cmd) = @_;
    $output .= strong($cmd) . br();
    $output .= "\n";

    open(SUBPROC, "$cmd 2>&1 |")
	or dienice("Couldn't open pipe from $cmd: $!");
	
    foreach my $cmdret (<SUBPROC>)
    {
	$output .= code($cmdret) . br() . "\n";
    }
    close SUBPROC;
    return(($? >> 8) & 255);
}

sub myrename
{
    my($arg1, $arg2) = @_;
    $output .= strong("mv $arg1 $arg2") . br();
    $output .= "\n";
    return(rename($arg1, $arg2));
}

sub dienice 
{
    my($msg) = @_;
    print "<h2>Error</h2>\n";
    print $msg;
    exit;
}
