#!/usr/bin/perl -wT
use CGI::Ajax;
use CGI qw(:standard *table);
use CGI::Carp qw(warningsToBrowser fatalsToBrowser);
use strict;

# tighten up the PATH
$ENV{"PATH"} = "/usr/bin";

print header;
print start_html( -title=>"Compiler Lab #1 - Lexical Analysis (Scanning)",
		  -style=>{-src=>"../style.css"}), "\n";

print "<div id=&quot;nav&quot;>";
print "<a href = \"http://www.cs.wpi.edu/~kal/courses/compilers/modules.html\">[Modules]</a>";
print "<a href = \"http://www.cs.wpi.edu/~kal/courses/compilers/syllabus.html\">[Syllabus]</a>";
print "<a href = \"http://www.cs.wpi.edu/~kal/courses/compilers/project/index.html\">[Project]</a>";
print "<a href = \"http://users.wpi.edu/~alexvo/index.html\">[Lab Index]</a>";
print "</div>";

print h1("Compiler Lab #1 - Lexical Analysis (Scanning)"), "\n";
print h2("Created by Todd Cooper &amp; Karen Lemone"), "\n";

my $instruct=<<ENDINSTRUCT;
<p>
This lab will prepare you to do Project, Part 1 which uses <i>lex</i> to generate a scanner
</p>

<p>
Below in the box on the left is a <i>lex</i> program that will create and run a scanner 
(lexical analyzer) when you click
on the button <i>Edit the text and click me</i>
</p>

<p> 
When you press the button <em>Edit the text and click me</em>, the following 
occurs:
</p>
<ol>
<li>The web page will be submitted to <i>flex,</i> a version of <i>lex</i> creating a Scanner
that will recognize the tokens described there. It is essentially a C program.</li>
<li>Then the C compiler (<i>cc</i>), compiles this to create an executable scanner.</li>
<li>This scanner runs the input program on the right producing a set of tokens.<br>  
You can see this list of tokens at the 
bottom of the output page. You might have to scroll down in your browser to 
see them.</li>
</ol>

<p>
<b>Step 1</b> Click on the button and investigate the output.
</p>

ENDINSTRUCT
print p, start_form(-method => "post",
		    -action => "scannerlab.cgi#output"), "\n";

print $instruct;
my $codefilename = "lex_code_$$";
my $inputcode = param("code");
my $inputtext = param("input");

open(CODEF,">$codefilename.l") 
    or dienice("Couldn't open $codefilename.l for creation: $!");
print CODEF $inputcode;
close CODEF;
open(INPUTF,">$codefilename.input") 
    or dienice("Couldn't open $codefilename.input for creation: $!");
print INPUTF $inputtext;
close INPUTF;

my $flexline = "flex -o$codefilename.c $codefilename.l";
my $compileline = "cc -o$codefilename $codefilename.c -lfl";
my $runline = "./$codefilename < $codefilename.input";
my $output;
if (runandoutput($flexline))
{
    $output .= "The flex command returned the error: $?\n";
}
elsif (runandoutput($compileline))
{
    $output .= "The compile command returned the error: $?\n";
}
elsif (runandoutput($runline))
{
    $output .= "The run command returned the error: $?\n";
}

print start_table();
print Tr(td({colspan => 2},
	    [submit(-name=>'submit',
		    -value=>'Edit the text and click me')])), "\n";
print Tr(td( {width => "50%"}, ["Lex Program"]),
	 td( {width => "50%"}, ["Scanner Input"])), "\n";
print Tr(td( {width => "50%"}, textarea(-name => 'code',
					-default => $inputcode,
                                        -rows => 21,
                                        -columns => 42)),
         td( {width => "50%"}, textarea(-name => 'input',
					-default => $inputtext,
                                        -rows => 21,
                                        -columns => 42))), "\n";

my $thtext = "Edit the program and input above" . br();
$thtext .= "and click on the button to see the result.";
print Tr(th( {align => "left"}, [$thtext] ));

print end_table(), "\n";
my $restext = "The result output or running the input on the lex program";
$restext .= " is below.";


print "<a name=\"output\"></a>";
print p($restext), "\n";
print "<fieldset><legend>OUTPUT</legend>";
print p($output), "\n";
print "</fieldset>";

print endform(), "\n";

my $htmlend=<<ENDHTMLEND;

<p>
<fieldset>
<legend>QUESTION 1</legend>
Looking at the lex code and the output, what tokens seem to be described there?
</fieldset>
</p>

<p>
<b>Step 2</b> Change the input to the following and click on the button again:
</p>

<p>
<code>
void input_a() {<br>
   a = b3;<br>
   xyz = a + b + c - p / q;<br>
   a = xyz * ( p + q );<br>
   p = a - xyz - p;<br>
}
</code>
<br>
</p>

<p>
<fieldset>
<legend>QUESTION 2</legend>
What tokens didn't get recognized?
</fieldset>
</p>

<p>
<b>Step 3</b>
<ul type="a">
<li>Change the lex file so that when it comes across an equal, it prints <code>EQUAL</code></li>
<li>Now change the lex file so that it recognizes all the tokens in the program in Step 2</li>
</ul>
</p>

<p>
<b>Step 4</b> Change the lex file so that it will also recognize an <i> integer </i> consisting 
of 1 or more digits
</p>

<p>
<b>Step 5</b> Using lex in Unix
</p>

<p>
<ul type="a">
<li>Create a file, <code>lex.a</code> containing your lex code from Step 4. (You can change it to print 
nicer output if you wish - in fact, I recommend this; Try printing the tokens as ordered pairs, e.g.,
 <code>(identifier, void)</code>).</li>
<li>Generate the C Program which is the Scanner as follows:</li>
</p>

<p>
<code>\$ lex lex.a</code>
<br>
</p>

<p>
Now let's see what files are there:
</p>

<p>
<code>
\$ ls
<br>
lex.a lex.yy.c <br>
</code>
</p>

<p>
You can see that lex has created a C program called <code>lex.yy.c</code>. 
This is our Scanner, but we have to compile it first:
</p>

<p>
<li>Compile  the C Program which is the Scanner:
</p>

<p>
<code>
\$ cc lex.yy.c -ll <br>
\$ ls<br>
a.out     lex.a     lex.yy.c <br>
</code>
</p>

<p>
<code>a.out</code> is the executable scanner. Let's try it out!
</p>
</li>
<p>
<li>Running the Scanner:
</p>

<p>
<code>
\$ ./a.out<br> 
23<br>
integer
</code>
</p>
</li>
</ul>

<p>
<b>Step 6</b> Now  change your <i> lex </i> file so that it displays <code>REALNUM</code> 
for a real number.<br>
A real number can be defined
as a plus or minus followed by a number of digits followed by a dot ".",
followed by a number of digits.
</p>

<p>
You are now ready to do Project, Part 1!
</p>

ENDHTMLEND
print $htmlend;
print end_html;

# cleanup files we made
unlink("$codefilename.l");
unlink("$codefilename.input");
unlink("$codefilename.c");
unlink("$codefilename");

sub runandoutput
{
    my($cmd) = @_;
    $output .= strong($cmd) . br() . br();
    $output .= "\n";

    open(SUBPROC, "$cmd 2>&1 |")
	or dienice("Couldn't open pipe from $cmd: $!");
	
    foreach my $cmdret (<SUBPROC>)
    {
	chomp $cmdret;
	$output .= code($cmdret) . br();
    }
    close SUBPROC;
    return(($? >> 8) & 255);
}

sub dienice 
{
    my($msg) = @_;
    print "<h2>Error</h2>\n";
    print $msg;
    exit;
}
